// 535 Matus Horvath

#include <stdlib.h>
#include <stdio.h>

int dvanax(int x) {
	int retval=1;
	for(int i=0;i<x;i++) retval*=2;
	return retval;
}

// pole, do ktoreho piseme vystup (globalne, aby som nemusel stale davat
// pointer na neho rekurzivnej funkcii)
int pole[128][128];
int znacka=1;

void rekurzia(int x,int y,int amin,int amax,int bmin,int bmax,int m) {
	if(m==1) {		// m=1, oznac L a vrat sa
		int pom=pole[x][y];
		pole[amin][bmin]=znacka;
		pole[amin][bmax]=znacka;
		pole[amax][bmin]=znacka;
		pole[amax][bmax]=znacka++;
		pole[x][y]=pom;

		return;
	}

	// zisti, v ktorej stvrtine pola je vystrihnute
	int pola=(amin+amax+1)/2;		//polovice stran pola       3 4
	int polb=(bmin+bmax+1)/2;   //                          1 2

	if((x<pola)&&(y<polb)) {					//vystrihnute je v 1. stvrtine
		rekurzia(x,y,amin,pola-1,bmin,polb-1,m-1);						//1.-
		rekurzia(pola,polb-1,pola,amax,bmin,polb-1,m-1);  		//2.
		rekurzia(pola-1,polb,amin,pola-1,polb,bmax,m-1);  		//3.
		rekurzia(pola,polb,pola,amax,polb,bmax,m-1);      		//4.
		pole[pola][polb-1]=znacka; 	//2.
		pole[pola-1][polb]=znacka; 	//3.
		pole[pola][polb]=znacka++;			//4.
	} else if((x>=pola)&&(y<polb)) {	//vystrihnute je v 2. stvrtine
		rekurzia(pola-1,polb-1,amin,pola-1,bmin,polb-1,m-1);	//1.
		rekurzia(x,y,pola,amax,bmin,polb-1,m-1);          		//2.-
		rekurzia(pola-1,polb,amin,pola-1,polb,bmax,m-1);  		//3.
		rekurzia(pola,polb,pola,amax,polb,bmax,m-1);      		//4.
		pole[pola-1][polb-1]=znacka; //1.
		pole[pola-1][polb]=znacka; 	//3.
		pole[pola][polb]=znacka++;			//4.
	} else if((x<pola)&&(y>=polb)) {	//vystrihnute je v 3. stvrtine
		rekurzia(pola-1,polb-1,amin,pola-1,bmin,polb-1,m-1);	//1.
		rekurzia(pola,polb-1,pola,amax,bmin,polb-1,m-1);  		//2.
		rekurzia(x,y,amin,pola-1,polb,bmax,m-1);							//3.-
		rekurzia(pola,polb,pola,amax,polb,bmax,m-1);      		//4.
		pole[pola-1][polb-1]=znacka; //1.
		pole[pola][polb-1]=znacka; 	//2.
		pole[pola][polb]=znacka++;			//4.
	} else {                          //vystrihnute je v 4. stvrtine
		rekurzia(pola-1,polb-1,amin,pola-1,bmin,polb-1,m-1);	//1.
		rekurzia(pola,polb-1,pola,amax,bmin,polb-1,m-1);  		//2.
		rekurzia(pola-1,polb,amin,pola-1,polb,bmax,m-1);  		//3.
		rekurzia(x,y,pola,amax,polb,bmax,m-1);            		//4.-
		pole[pola-1][polb-1]=znacka; //1.
		pole[pola][polb-1]=znacka; 	//2.
		pole[pola-1][polb]=znacka++; 	//3.
	}
}

int main() {
//	FILE *fin,*fout;

//	fin=fopen("sept3.in","rt");
//	fout=fopen("sept3.out","wt");

	int m,x,y; 	// vstup;
	int n;

	char buf[20];
	int i,j;


	while(1) {
		sscanf(fgets(buf,20,stdin),"%i %i %i",&m,&x,&y);

		if((!m)&&(!x)&&(!y)) {	// tri nuly => koniec
//			fclose(fin);
//			fclose(fout);
			return 0;
		}

		n=dvanax(m);
		x--;	// pouzivame suradnice od 0 po n-1, nie od 1 po n ako v zadani
		y--;

		pole[x][y]=0;	// oznacime vystrihnute policko
		znacka=1;			// nastavime znacku na 1

		// spustime rekurziu stupna m pre policko (0..n-1)x(0..n-1)
		rekurzia(x,y,0,n-1,0,n-1,m);

		for(j=n-1;j>=0;j--) {
			for(i=0;i<n;i++) {
				fprintf(stdout,"%04i ",pole[i][j]);
			}
			fprintf(stdout,"\n");
		}
		fprintf(stdout,"---\n");
	}
}